/*
 *      Copyright(C) 2001-2004 NAKAYAMA Hiroyoshi
 *
 * 	Licensed under the terms of the GNU GPL License version 2.
 */
#ifndef __MISCIO_H__
#define __MISCIO_H__

typedef enum {
  NOARG,FLAG,INT,FLOAT,STRINGS,CHAR,END
} ARGTYPE;

typedef struct ARGOPTION {
  char           *option;
  ARGTYPE         type;
  union data {
    int     flag;
    int     idata;
    double  fdata;
    char   *sdata;
    char    cdata;
  } data;
} ARGOPTION;

/*
 * ȒPargument`FbN邽߂̊֐
 */
int ArgGetOption(struct ARGOPTION *argoption, int argc, char *argv[]);
int FArgGetOption(struct ARGOPTION *argoption, char *file);

/*
 * ꂼA[Mg"str"̌̌̕^ɕϊAԂB
 * "str"Ȃꍇ́AȂB
 * ԂĺA"str"A[Mgɂꍇ 1,Ȃ 0.
 */
int Arg2i(int argc, char *argv[], char *str, int    *r);
int Arg2f(int argc, char *argv[], char *str, double *r);
int Arg2s(int argc, char *argv[], char *str, char  **r);
int Arg2c(int argc, char *argv[], char *str, char   *r);

/*
 * ԂĺA"str"A[Mgɂꍇ 1,Ȃ 0.
 */
int ArgFlag(int argc, char *argv[], char *str);

/*
 * t@C̓eA[Mǧ`ɕϊ.
 * ϊ̌ɏL̊֐ Arg* gB
 * ԂĺAt@Cĕϊꍇ 1,Ȃꍇ 0.
 */
int  File2Arg(char *filename, int *fargc, char ***fargv);
void File2ArgFree(int fargc, char **fargv);

/*
 * 킸ƒmꂽt@C̒Pꒊo֐.
 * LFile2ArgłgĂB
 * ԂĺAt@C̍sԍBl0Ńt@C̏C܂D
 */
int GetWord(FILE *, char *);

/*
 * ϐ̃pXāAt@CI[vB
 * ؂蕶":",";"2B
 */
FILE *FileOpen(char *file, char *mode, char *env);

#endif
